import type { Data, Transaction } from "./types";
declare type Params<Domain> = {
    commitTransaction: (transaction: Transaction<Domain>) => Promise<void>;
    onChangePendingTransactionCount: () => void;
    onError: (error: Error) => void;
    onRerenderKind: <K extends keyof Domain>(kind: K, id: string) => void;
    optimisticUIEnabled: () => boolean;
};
export declare function optimisticUi<Domain>(params: Params<Domain>): {
    addTransaction: (transaction: Transaction<Domain>) => void;
    pendingTransactionCount: () => number;
    withPendingTransactions: (data: Data<Domain>) => Data<Domain>;
};
export {};
