import type { NetworkAdapter } from "../../network/types";
import type { Data } from "../types";
declare type Params<Domain> = {
    canonData: Data<Domain>;
    network: NetworkAdapter<Domain>;
    onChange: (kind: keyof Domain, id: string) => void;
    onConnectivityChange: () => void;
    onError: (err: Error) => void;
    shouldCrashWrites: () => boolean;
};
export declare function sync<Domain>(params: Params<Domain>): {
    connectivity: () => import("../types").Connectivity;
    observe: <K extends keyof Domain>(kind: K, id: string) => () => void;
    push: (transaction: import("../types").Transaction<Domain, keyof Domain>) => Promise<void>;
};
export {};
