"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.makeKindIdStore = void 0;
function makeKindIdStore(defaultValue) {
    var store = {};
    return {
        get: function (kind, id) {
            store[kind] = store[kind] || {};
            var kindStore = store[kind];
            if (!kindStore)
                throw new Error();
            kindStore[id] = kindStore[id] || defaultValue;
            var value = kindStore[id];
            if (!value)
                throw new Error();
            return value;
        },
    };
}
exports.makeKindIdStore = makeKindIdStore;
//# sourceMappingURL=kindIdStore.js.map