import type { PushResult } from "../../network/types";
import type { Data, Transaction } from "../types";
declare type Params<Domain> = {
    canonData: Data<Domain>;
    onError: (err: Error) => void;
    onNetPush: <K extends keyof Domain>(params: {
        kind: K;
        id: string;
        lastSeenRevision: string;
        pushId: string;
        value: Domain[K];
    }) => Promise<PushResult<Domain[K]>>;
    onUpdate: <K extends keyof Domain>(params: {
        kind: K;
        id: string;
        newRevision: string;
        newValue: Domain[K];
    }) => void;
    shouldCrashWrites: () => boolean;
};
export declare function makePush<Domain>(params: Params<Domain>): (transaction: Transaction<Domain>) => Promise<void>;
export {};
