"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.makePush = void 0;
var kindIdStore_1 = require("./kindIdStore");
var throttled_1 = require("./throttled");
var defaultRetries = 15;
var sleep = function (ms) { return new Promise(function (resolve) { return setTimeout(resolve, ms); }); };
function makePush(params) {
    var canonData = params.canonData, onError = params.onError, onNetPush = params.onNetPush, onUpdate = params.onUpdate, shouldCrashWrites = params.shouldCrashWrites;
    var pushCounter = 0;
    function attemptPush(pushParams) {
        return __awaiter(this, void 0, void 0, function () {
            var kind, id, actions, previousConflictOnRevision, retriesRemaining, curr, value, lastSeenRevision, pushId, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!shouldCrashWrites()) return [3 /*break*/, 2];
                        return [4 /*yield*/, sleep(2000)];
                    case 1:
                        _a.sent();
                        throw new Error("Simulate write failure");
                    case 2:
                        kind = pushParams.kind, id = pushParams.id, actions = pushParams.actions, previousConflictOnRevision = pushParams.previousConflictOnRevision, retriesRemaining = pushParams.retriesRemaining;
                        curr = canonData[kind][id];
                        value = actions.reduce(function (prev, action) {
                            if ("creation" in action)
                                return action.creation;
                            if (!prev)
                                throw new Error("Pushing to " + kind + " while the canon data is empty is not yet implemented. Proper implementation turns on observing here, waits for the data and tries to push.");
                            return action.delta(prev);
                        }, curr && curr.value);
                        if (!value)
                            throw new Error("Some transaction on " + kind + " " + id + " returned a falsy value.");
                        lastSeenRevision = curr ? curr.revision : "creating-new-item";
                        pushId = "push-" + pushCounter++;
                        return [4 /*yield*/, onNetPush({
                                kind: kind,
                                id: id,
                                pushId: pushId,
                                lastSeenRevision: lastSeenRevision,
                                value: value,
                            })];
                    case 3:
                        result = _a.sent();
                        if (!(result === "conflict")) return [3 /*break*/, 5];
                        if (lastSeenRevision === "creating-new-item") {
                            throw new Error("Failed to create new item " + kind + " " + id + ". Check whether the server correctly allows creating new items and that your id is uniqely generated.");
                        }
                        if (previousConflictOnRevision &&
                            lastSeenRevision === previousConflictOnRevision) {
                            throw new Error("The revision " + lastSeenRevision + " is not changing and the server keeps responding with a conflict. Check whether the server is correctly incrementing the revision, whether the server is correctly sending updates with new revisions, and whether the client is subscribed to updates on " + kind + " " + id + ".");
                        }
                        return [4 /*yield*/, attemptPush(__assign(__assign({}, pushParams), { previousConflictOnRevision: lastSeenRevision, retriesRemaining: defaultRetries }))];
                    case 4: 
                    // Server and the connection are healthy, so reset the retries
                    // We can resolve conflicts infinitely, it’s the internal errors that
                    // we need to limit retries.
                    return [2 /*return*/, _a.sent()];
                    case 5:
                        if (!(result === "internalError")) return [3 /*break*/, 8];
                        // As many other pieces of this code, the retry logic needs
                        // cleaner refactoring
                        if (retriesRemaining === 0)
                            throw new Error("Write failed after all retries");
                        return [4 /*yield*/, sleep(3000)];
                    case 6:
                        _a.sent();
                        return [4 /*yield*/, attemptPush(__assign(__assign({}, pushParams), { retriesRemaining: retriesRemaining - 1 }))];
                    case 7: return [2 /*return*/, _a.sent()];
                    case 8:
                        if (typeof result === "object") {
                            onUpdate(__assign({ kind: kind, id: id }, result));
                            return [2 /*return*/];
                        }
                        throw new Error("Unexpected result " + result);
                }
            });
        });
    }
    var queuedTasks = kindIdStore_1.makeKindIdStore([]);
    function performPush(kind, id) {
        return __awaiter(this, void 0, void 0, function () {
            var taskQueue, tasks, err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        taskQueue = queuedTasks.get(kind, id);
                        tasks = taskQueue.slice();
                        taskQueue.splice(0);
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, attemptPush({
                                kind: kind,
                                id: id,
                                actions: tasks.map(function (t) { return t.action; }),
                                retriesRemaining: defaultRetries,
                            })];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        err_1 = _a.sent();
                        onError(err_1);
                        return [3 /*break*/, 4];
                    case 4:
                        tasks.forEach(function (t) { return t.resolve(); });
                        return [2 /*return*/];
                }
            });
        });
    }
    var run = throttled_1.makeThrottled(performPush);
    return function (transaction) {
        var kind = transaction.kind, id = transaction.id;
        return new Promise(function (resolve) {
            queuedTasks.get(kind, id).push({ action: transaction, resolve: resolve });
            run(kind, id);
        });
    };
}
exports.makePush = makePush;
//# sourceMappingURL=push.js.map