"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.makeThrottled = void 0;
var kindIdStore_1 = require("./kindIdStore");
function makeThrottled(f) {
    var schedules = kindIdStore_1.makeKindIdStore({});
    return function (kind, id) {
        var schedule = schedules.get(kind, id);
        function run() {
            if (schedule.debounceTimer)
                clearTimeout(schedule.debounceTimer);
            if (schedule.maxTimer)
                clearTimeout(schedule.maxTimer);
            schedule.maxTimer = undefined;
            f(kind, id);
        }
        if (schedule.debounceTimer)
            clearTimeout(schedule.debounceTimer);
        schedule.debounceTimer = setTimeout(run, 500);
        if (!schedule.maxTimer) {
            schedule.maxTimer = setTimeout(run, 10000);
        }
    };
}
exports.makeThrottled = makeThrottled;
//# sourceMappingURL=throttled.js.map