"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.makeDummyAdapter = void 0;
var defaultOnMissing = function (kind, id) {
    throw new Error("Missing dummy data " + kind + " " + id);
};
function makeDummyAdapter(data, opts) {
    if (opts === void 0) { opts = {}; }
    // Clone data one level deep
    var _ = data;
    data = {};
    Object.keys(_).forEach(function (k) {
        data[k] = __assign({}, _[k]);
    });
    var onMissing = opts.onMissing || defaultOnMissing;
    var locks = new Set();
    return function (_a) {
        var onChange = _a.onChange, onConnectivityChange = _a.onConnectivityChange, onPushResult = _a.onPushResult;
        setTimeout(function () { return onConnectivityChange("online"); }, 1000);
        return {
            getAndObserve: function (kind, id) {
                setTimeout(function () {
                    onChange({
                        kind: kind,
                        id: id,
                        revision: "dummy",
                        value: id in data[kind] ? data[kind][id] : onMissing(kind, id),
                    });
                }, 1500);
                return function () { };
            },
            push: function (_a) {
                var kind = _a.kind, id = _a.id, pushId = _a.pushId, value = _a.value;
                var lockKey = kind + "-" + id;
                if (locks.has(lockKey)) {
                    setTimeout(function () { return onPushResult(pushId, "conflict"); }, 500);
                    return;
                }
                locks.add(lockKey);
                setTimeout(function () {
                    var kindCollection = data[kind];
                    kindCollection[id] = value;
                    onChange({ kind: kind, id: id, revision: "dummy", value: value });
                    onPushResult(pushId, { newRevision: "dummy", newValue: value });
                    locks.delete(lockKey);
                }, 2000);
            },
        };
    };
}
exports.makeDummyAdapter = makeDummyAdapter;
//# sourceMappingURL=dummy.js.map