"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _1 = require(".");
function testWsAdapter() {
    var sentMessages = [];
    var partialSocket = {
        send: function (data) {
            sentMessages.push(JSON.parse(String(data)));
        },
    };
    var socket = partialSocket;
    var sock = socket;
    var wsp = _1.makeWsProtocolAdapter({
        url: "",
        _socket: socket,
    });
    var adapter = wsp.adapter({
        onChange: function () { },
        onConnectivityChange: function () { },
        onError: function () { },
        onPushResult: function () { },
    });
    return {
        adapter: adapter,
        auth: wsp.auth,
        disconnect: function () {
            if (socket.onclose)
                socket.onclose({});
            sock.readyState = 0;
        },
        connect: function () {
            if (socket.onopen)
                socket.onopen({});
            sock.readyState = 1;
        },
        sentMessages: sentMessages,
    };
}
exports.default = testWsAdapter;
//# sourceMappingURL=testWsAdapter.js.map