/// <reference types="react" />
import { CreateParams, Data } from "../../core";
import type { ReactType } from "./types";
declare type Configuration<Domain> = {
    data: Data<Domain>;
    React: ReactType;
};
export declare function configure<Domain>(configuration: Configuration<Domain>): {
    create: (params: CreateParams<Domain>) => {
        db: import("../../core").FullDB<Domain>;
        withDB: (children: import("react").ReactNode) => import("react").CElement<{
            value: import("../../core").FullDB<Domain>;
            children: import("react").ReactNode;
        }, import("react").Component<{
            value: import("../../core").FullDB<Domain>;
            children: import("react").ReactNode;
        }, any, any>>;
    };
    SemiControlledInput: (props: import("react").InputHTMLAttributes<HTMLInputElement>) => import("react").DetailedReactHTMLElement<import("react").InputHTMLAttributes<HTMLInputElement>, HTMLInputElement>;
    useTryDB: () => "missing-provider" | import("../../core").FullDB<Domain>;
    useConnectivity: () => import("../../core").Connectivity;
    useCreate: <K extends keyof Domain>(kind: K) => (id: string, value: Domain[K]) => void;
    useData: <K_1 extends keyof Domain>(kind: K_1, id: string) => ["loading" | Domain[K_1], import("./hooks").Updater<Domain[K_1]>];
    useMultipleData: <K_2 extends keyof Domain>(kind: K_2, ids: string[]) => ["loading" | {
        [id: string]: Domain[K_2];
    }, (id: string, delta: (prev: Domain[K_2]) => Domain[K_2]) => void];
    useOncillaDebug: () => [import("../../core").DebugConfig, (partial: Partial<import("../../core").DebugConfig>) => void];
    usePendingChanges: () => number;
};
export {};
