"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.configure = void 0;
var core_1 = require("../../core");
var context_1 = require("./context");
var hooks_1 = require("./hooks");
var inputs_1 = require("./inputs");
function configure(configuration) {
    var data = configuration.data, React = configuration.React;
    var _a = context_1.createContext({ React: React }), Provider = _a.Provider, useTryDB = _a.useTryDB;
    var hooks = hooks_1.makeHooks({ useTryDB: useTryDB, React: React });
    return __assign(__assign({}, hooks), { create: function (params) {
            var db = core_1.create(__assign(__assign({}, params), { initialData: data }));
            var withDB = function (children) {
                return React.createElement(Provider, { value: db, children: children });
            };
            return { db: db, withDB: withDB };
        }, SemiControlledInput: inputs_1.makeSemiControlledInput(React), useTryDB: useTryDB });
}
exports.configure = configure;
//# sourceMappingURL=configure.js.map