import type { DebugConfig, FullDB } from "../../core";
import type { ReactType } from "./types";
declare type MassUpdaterInternal<Domain, K extends keyof Domain> = (options: {}, kind: K, id: string, delta: (prev: Domain[K]) => Domain[K]) => void;
export declare type MassUpdater<Domain, K extends keyof Domain> = MassUpdaterInternal<Domain, K> & {
    (kind: K, id: string, delta: (prev: Domain[K]) => Domain[K]): void;
};
declare type UpdaterInternal<T> = (options: {}, delta: (prev: T) => T) => void;
export declare type Updater<T> = UpdaterInternal<T> & {
    (delta: (prev: T) => T): void;
} & (T extends {} ? {
    <K extends keyof T & string>(field: K, value: T[K]): void;
} : {});
declare type Changer<T> = [T | "loading", Updater<T>];
export declare function makeHooks<Domain>(params: {
    React: ReactType;
    useTryDB: () => FullDB<Domain> | "missing-provider";
}): {
    useConnectivity: () => import("../../core").Connectivity;
    useCreate: <K extends keyof Domain>(kind: K) => (id: string, value: Domain[K]) => void;
    useData: <K_1 extends keyof Domain>(kind: K_1, id: string) => Changer<Domain[K_1]>;
    useMultipleData: <K_2 extends keyof Domain>(kind: K_2, ids: string[]) => [{
        [id: string]: Domain[K_2];
    } | "loading", (id: string, delta: (prev: Domain[K_2]) => Domain[K_2]) => void];
    useOncillaDebug: () => [DebugConfig, (partial: Partial<DebugConfig>) => void];
    usePendingChanges: () => number;
};
export {};
