"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.makeSemiControlledInput = void 0;
function makeSemiControlledInput(React) {
    return function SemiControlledInput(props) {
        var defaultValue = props.defaultValue, onBlur = props.onBlur, onChange = props.onChange, onFocus = props.onFocus, value = props.value;
        if (defaultValue !== undefined)
            throw new Error("Use SemiControlledInput with onChange and value, not defaultValue");
        var _a = React.useState(false), focused = _a[0], setFocused = _a[1];
        var _b = React.useState(value), valueUnderEdit = _b[0], setValueUnderEdit = _b[1];
        return React.createElement("input", __assign(__assign({}, props), { onBlur: function (e) {
                if (onChange && valueUnderEdit !== value)
                    onChange({ target: e.target });
                if (onBlur)
                    onBlur(e);
                setFocused(false);
            }, onChange: function (e) { return setValueUnderEdit(e.target.value); }, onFocus: function (e) {
                setValueUnderEdit(value);
                setFocused(true);
                if (onFocus)
                    onFocus(e);
            }, value: focused ? valueUnderEdit : value }));
    };
}
exports.makeSemiControlledInput = makeSemiControlledInput;
//# sourceMappingURL=inputs.js.map