"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.makeReactMock = exports.build = void 0;
var react_1 = __importDefault(require("react"));
var configure_1 = require("./configure");
var mocks_1 = require("../mocks");
function build(t, data) {
    var react = makeReactMock();
    var configured = configure_1.configure({
        data: data,
        React: react,
    });
    var db = configured.create({
        network: mocks_1.makeDummyAdapter(data),
        onError: function (err) { return t.fail(err.message); },
        window: mocks_1.makeWindowMock(),
    }).db;
    react._setContextValue(db);
    return configured;
}
exports.build = build;
function makeReactMock() {
    var contextValue = "missing-provider";
    var reactStub = __assign(__assign({}, react_1.default), { createContext: function () { return ({}); }, useCallback: function (f) { return f; }, useContext: function () { return contextValue; }, useEffect: function () { }, useReducer: function (_, state) { return [state, function () { }]; } });
    return __assign(__assign({}, reactStub), { _setContextValue: function (val) {
            contextValue = val;
        } });
}
exports.makeReactMock = makeReactMock;
//# sourceMappingURL=mocks.js.map